/*** Sensible Floor Entrance ***
 * This sketch coomunicates with the Arduino code called "SotoportegoDoorArduino".
 * 
 * This Processing file is part of:
 * ROUTES, a project by Maria Gabriella Astolfo, Alberto Elizondo and Marco Righetto
 * This code is modified from an original code by Bill Graner http://interactive.usc.edu/members/wgraner/2009/04/example_code_for_communicating.html
 * http://www.interaction-venice.com/projects/iuav09-10Lab2/about/routes/
 * 
 * IUAV University of Venice - Design&Arts Faculty
 * IxD Lab 2 - January-April 2010
 * 
 * Tutors: Philip Tabor and Gillian Crampton-Smith
 * Thanks to Tom Hulbert and Durrel Bishop
 * 
 ***/

// Loads libraries//

import processing.serial.*;
import krister.Ess.*;

// Declare classes that load the audio files

AudioChannel myChannel;
AudioChannel myChannel_2;

// Communication with Arduino

Serial port;
String buff = "";
int NEWLINE = 10;
String data;
int[] data_list; //the array receives the input from the switch

void setup()
{
  size(500 , 500);
  data = "0,0";
  println("Available serial ports:");
  println(Serial.list());

  Ess.start(this);

  // loads the audio from the data folder

  myChannel=new AudioChannel("door.mp3");
  myChannel_2=new AudioChannel("crowd_outside_1.wav");

  // plays mychannel_2 (crow_outside_1.wav)

  myChannel_2.play(Ess.FOREVER);

  // sets the volume for mychannel_2 (crow_outside_1.wav)

  myChannel_2.volume(.3 );

  // Uses the first port in this list (number 0). The last
  // parameter (e.g. 9600) is the speed of the communication. It
  // has to correspond to the value passed to Serial.begin() in the
  // Arduino sketch.

  port = new Serial(this, Serial.list()[0], 9600); 

}

void draw()
{
  println(data_list);

  // the following piece of code loads the other audio file when the switch is pressed

  if (data_list != null) {
    if (data_list[0] == 1){
      myChannel.play();
      myChannel.volume(2);
    }

    else{
      background (0,255,0);
    }
  }



  while (port.available() > 0){
    serialEvent(port.read());
  }
}

// This is called when the sketch reads something from Arduino.

void serialEvent(int serial)
{


  
  if (serial != NEWLINE) {
    
    // Store all the characters on the line.
    
    buff += char(serial);
  } 
  else {
    
    // The end of each line is marked by two characters, a carriage
    // return and a newline. We're here because we've gotten a newline,
    // but we still need to strip off the carriage return.
    
    if (buff.length() > 0) {
      buff = buff.substring(0, buff.length()-1);
    }
    data = buff;
    data_list = int(split(data, ','));
    buff = "";
  }
}

public void stop() {
  Ess.stop();
  super.stop();
}





